/*
 * envtest.c -- Demonostrates accessing environment variables.
 *
 * Author: Randy L. Pearson
 * Date:   22 Jun 2004
 */
 
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

extern char ** environ;

int main()
{
	char * next;
	char * variable;
	char name[255];
	char value[255];
	char * sep;
	int index = 0;

	printf( "Trying to find environment variable named JUNK\n" );	
	variable = getenv( "JUNK" );
	if( variable )
		printf( "JUNK=%s\n", variable );
	else
		printf( "JUNK not found.\n" );
		
	printf( "Attempting to add/overwrite JUNK variable\n" );
	putenv( "JUNK=Testing" );
	
	printf( "Trying to find environment variable named JUNK again\n" );	
	variable = getenv( "JUNK" );
	if( variable )
		printf( "JUNK=%s\n", variable );
	else
		printf( "JUNK not found.\n" );
		
	printf( "\nShowing entire environment\n" );
	printf( "==========================\n" );
	
	next = environ[index++];
	while( next && strlen(next) )
	{
		if( strlen(next) > 254 )
		{
			sep = strchr(next, '=');
			strncpy( name, next, sep-next );
			name[sep-next] = '\0';
			printf( "*** Error ***: Variable \"%s\" is too long.  Skipping...\n", name );
		}
		else
		{
			strcpy( name, next );
			sep = strchr( name, '=' );
			if( sep )
			{
				strcpy( value, sep+1 );
				*sep = '\0';
				printf( "%s=%s\n", name, value );
			}
			else
			{
				printf( "Huh?  \"%s\" not recognized as valid environment variable.\n", next );
			}
		}
		next = environ[index++];
	}
	
	printf( "That's all folks...\n" );
	return 0;
}
