/*
 * hostinfo.c -- Displays various information about the host computer.
 *
 * Author: Randy L. Pearson
 * Date:   22 Jun 2004
 */
 
#include <stdio.h>
#include <unistd.h>
#include <sys/utsname.h>

int main()
{
	char hostname[255];
	char domain[255];
	struct utsname uname_info;
	long hostid;
	
	gethostname( hostname, sizeof(hostname) );
	getdomainname( domain, sizeof(domain) );
	uname( &uname_info );
	hostid = gethostid();
	
	printf( "Hostname: %s\n", hostname );
	printf( "Domain: %s\n", domain );
	printf( "Host ID: %08lx", hostid );
	printf( " aka (%d.%d.%d.%d)\n", (hostid >> 16) & 0xFF, (hostid >> 24) & 0xFF, hostid & 0xFF, (hostid >> 8) & 0xFF );
	
	printf( "uname.sysname: %s\n", uname_info.sysname );
	printf( "uname.nodename: %s\n", uname_info.nodename );
	printf( "uname.release: %s\n", uname_info.release );
	printf( "uname.version: %s\n", uname_info.version );
	printf( "uname.machine: %s\n", uname_info.machine );
	
#ifdef _GNU_SOURCE
	printf( "uname.domainname: %s\n", uname_info.domainname );
#endif

	return 0;
}
