/*
 * ttytest.c -- Demonstrates using a TTY terminal
 *
 * Author: Randy L. Pearson
 * Date:   6 Jul 2004
 */
 
#include <unistd.h>
#include <stdio.h>

int main()
{
	FILE *tty = fopen( "/dev/tty", "w" );
	
	if( !isatty(fileno(stdout)) )
	{
		printf( "This is redirected to the output file.\n" );
		fprintf( stderr, "You have redirected the output.\n" );
	}
	else
	{
		printf( "Ouput is not being redirected.\n" );
	}

	fprintf( tty, "This is always sent to the terminal.\n" );
	fprintf( tty, "The stdout device is named: %s\n", ttyname(fileno(stdout)) );
	fprintf( tty, "The tty device is named: %s\n", ttyname(fileno(tty)) );
	fclose( tty );
}
